Index: ogg123.h
===================================================================
RCS file: /usr/local/cvsroot/vorbis-tools/ogg123/ogg123.h,v
retrieving revision 1.3
diff -u -r1.3 ogg123.h
--- ogg123.h	2000/12/30 05:44:31	1.3
+++ ogg123.h	2001/01/25 01:55:47
@@ -14,6 +14,7 @@
   int driver_id;
   ao_device_t *device;
   ao_option_t *options;
+  int rate, channels;
   struct devices_s *next_device;
 } devices_t;
 
Index: ogg123.c
===================================================================
RCS file: /usr/local/cvsroot/vorbis-tools/ogg123/ogg123.c,v
retrieving revision 1.20
diff -u -r1.20 ogg123.c
--- ogg123.c	2001/01/22 21:19:57	1.20
+++ ogg123.c	2001/01/25 01:55:47
@@ -99,7 +99,6 @@
     ao_option_t *temp_options = NULL;
     int temp_driver_id = -1;
     devices_t *current;
-    int bits, rate, channels;
     buf_t *buffer = NULL;
 
     opt.read_file = NULL;
@@ -184,11 +183,6 @@
 
     /* Open all of the devices */
 
-    /* FIXME: OggVorbis files aren't all 16 bit 44.1k stereo. */
-    /* Heck, they might not even be Vorbis :) PCM-Ogg? */
-    bits = 16;
-    rate = 44100;
-    channels = 2;
     current = opt.outdevices;
 
     if (opt.verbose > 0)
@@ -203,15 +197,10 @@
 	    fprintf(stderr, "Comments: %s\n", info->comment);
 	}
 
-	current->device = ao_open(current->driver_id, bits, rate, channels,
-				  current->options);
-	if (current->device == NULL) {
-	    fprintf(stderr, "Error opening device.\n");
-	    exit(1);
-	}
 	if (opt.quiet < 1)
 	    fprintf(stderr, "\n");	// Gotta keep 'em separated ...
 
+	current->device = NULL;
 	current = current->next_device;
     }
 
@@ -274,7 +263,8 @@
     double t_sec = 0, c_sec = 0, r_sec = 0;
     int is_big_endian = ao_is_big_endian();
     double realseekpos = opt.seekpos;
-
+    devices_t * current;
+    
     /* Junk left over from the failed info struct */
     double u_time, u_pos;
 
@@ -371,6 +361,25 @@
 	int i;
 	vorbis_comment *vc = ov_comment(&vf, -1);
 	vorbis_info *vi = ov_info(&vf, -1);
+
+	/* Reopen devices if the sampling rate or number of channels needs to be changed */
+	/* FIXME: This breaks output to a file! */
+	current=opt.outdevices;
+	while(current != NULL) {
+		if(!current->device || current->rate!=vi->rate || current->channels!=vi->channels) {
+			if(current->device != NULL)
+				ao_close(current->device);
+			current->device = ao_open(current->driver_id, 16, vi->rate, vi->channels, current->options);
+			if (current->device == NULL) {
+			    fprintf(stderr, "Error opening device.\n");
+			    exit(1);
+			}
+
+			current->rate = vi->rate;
+			current->channels = vi->channels;
+		}
+		current=current->next_device;
+	}
 
 	if (opt.quiet < 1) {
 	    for (i = 0; i < vc->comments; i++) {
